The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Modulate Class Reference

STK periodic/random modulator. More...

`#include <Modulate.h>`

Inheritance diagram for stk::Modulate:

## Public Member Functions
| Modulate (void)
| Class constructor.
| ~Modulate (void)
| Class destructor.
void | reset (void)
| Reset internal state.
void | setVibratoRate (StkFloat rate)
| Set the periodic (vibrato) rate or frequency in Hz.
void | setVibratoGain (StkFloat gain)
| Set the periodic (vibrato) gain.
void | setRandomRate (StkFloat rate)
| Set the periodic (vibrato) rate or frequency in Hz.
void | setRandomGain (StkFloat gain)
| Set the random modulation gain.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK periodic/random modulator.

This class combines random and periodic modulations to give a nice, natural human modulation function.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ Modulate()

stk::Modulate::Modulate | ( | void |  | ) |

Class constructor.

An StkError can be thrown if the rawwave path is incorrect.

## Member Function Documentation

## ◆ tick()

StkFrames & stk::Modulate::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = 0 )
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

93{
94#if defined(_STK_DEBUG_)
95 if ( channel >= frames.channels() ) {
96 oStream_ << "Modulate::tick(): channel and StkFrames arguments are incompatible!";
97 handleError( StkError::FUNCTION_ARGUMENT );
98 }
99#endif
100
101 StkFloat *samples = &frames[channel];
102 unsigned int hop = frames.channels();
103 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
104 *samples = Modulate::tick();
105
106 return frames;
107}
stk::Modulate::tick
StkFloat tick(void)
Compute and return one output sample.
Definition Modulate.h:80
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- Modulate.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.